﻿Type=Class
Version=2.5
ModulesStructureVersion=1
B4i=true
@EndOfDesignText@
'version 0.9
'Class module
Sub Class_Globals
	Private mCam As LLCamera 'ignore
	Private nativeMe As NativeObject
	Private device As NativeObject
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize (Cam As LLCamera)
	nativeMe = Me
	mCam = Cam
	device = Cam
	device = device.GetField("device")
End Sub

Public Sub SetExposureAndISO(ExposureMs As Int, ISO As Float)
	nativeMe.RunMethod("setExposureAndISO:::", Array(device, ExposureMs, ISO))
End Sub

Public Sub MinISO As Float
	Return device.GetField("activeFormat").GetField("minISO").AsNumber
End Sub

Public Sub MaxISO As Float
	Return device.GetField("activeFormat").GetField("maxISO").AsNumber
End Sub

Public Sub MinExposureDuration As Int
	Dim cmtime As NativeObject = device.GetField("activeFormat").GetField("minExposureDuration")
	Return nativeMe.RunMethod("CMTimeToMilliseconds:", Array(cmtime)).AsNumber
End Sub

Public Sub MaxExposureDuration As Float
	Dim cmtime As NativeObject = device.GetField("activeFormat").GetField("maxExposureDuration")
	Return nativeMe.RunMethod("CMTimeToMilliseconds:", Array(cmtime)).AsNumber
End Sub
'Gets or sets the focus modes. The possible values are:
'0 - Locked, 1 - AutoFocus, 2 - ContinuousAutoFocus 
Public Sub getFocusMode As Int
	Return device.GetField("focusMode").AsNumber
End Sub

Public Sub setFocusMode(v As Int)
	device.SetField("focusMode", v)
End Sub

#If OBJC
- (int)CMTimeToMilliseconds:(NSValue*)time {
	return CMTimeGetSeconds(time.CMTimeValue) * 1000;
}
- (void)setExposureAndISO:(AVCaptureDevice*)device :(int)Exposure :(float)ISO {
	CMTime duration = CMTimeMake(Exposure, 1000);
	[device setExposureModeCustomWithDuration:duration ISO:ISO completionHandler:nil];
}
#End If